//Right Gutter
(function()
{
	//=================================================
	// VARIABLES
	//-------------------------------------------------
	var self, adId, rnd, uid;

	//=================================================
	// CONSTRUCTOR
	//-------------------------------------------------
	/**
	 * Creates the CustomFormat object with Videowall template specific logic.
	 *
	 * @constructor
	 * @this {CustomFormat}
	 */
	function Creative()
	{
		self = this;
 		window.addEventListener("message", function() { self.eventManager.apply(this, arguments); }, false);
	}

	//-------------------------------------------------------------------------------------------------------------------------------------------------------
	//=================================================
	// METHODS
	//-------------------------------------------------

 	Creative.prototype =
	{
		//=================================================
			// HTML5 Event System
		//-------------------------------------------------
		addJSEventListener: function(eventName, callback, interAd)
		{
			self.listenerQueue = self.listenerQueue || {};
			var data = {
				uid						: uid,
				listenerId				: Math.ceil(Math.random() * 1000000000),
				eventName				: eventName,
				interAd					: !!(interAd),
				creativeIFrameId		: self.creativeIFrameId
			};
			EB._sendMessage("ADD_JS_EVENT_LISTENER", data);
			data.callback 						= callback;
			self.listenerQueue[data.listenerId] = data;
			return data.listenerId;
	    },

		dispatchJSEvent: function(eventName, params)
		{
			params 						= params || {};
			params.uid 					= uid;
			params.eventName 			= eventName;
			params.creativeIFrameId		= self.creativeIFrameId;
			EB._sendMessage("DISPATCH_JS_EVENT", params);
		},

		removeJSEventListener: function(listenerId)
		{
			var params 				= {
				uid 				: uid,
				listenerId 			: listenerId,
				creativeIFrameId 	: self.creativeIFrameId
			};
			EB._sendMessage("REMOVE_JS_EVENT_LISTENER", params);
			if (self.listenerQueue[listenerId]) delete self.listenerQueue[listenerId];
		},

		eventManager: function(event)
		{
			var msg = JSON.parse(event.data);
			
			if(msg.type && msg.data && msg.data.uid && msg.data.uid == uid)
	        {
				switch (msg.type)
				{
					case "SEND_CREATIVE_ID":
						self.creativeIFrameId = msg.data.creativeIFrameId;
							if(creativeContainerReady) creativeContainerReady();
						break;
					case "EVENT_CALLBACK": // Handle Callback 
						var list 	= msg.data.listenerIds;
						var length  = list.length;
						for (var i = 0; i < length; i++)
						{
							try
							{
								var t = self.listenerQueue[list[i]];
								if (!t) continue;
								t.callback(msg.data);
							}
							catch (e){}
						}
						break;
				}
	        }
		}
		//-------------------------------------------------
			//End of HTML5 Event System
		//=================================================
	};

	//=================================================
	// Creative Functions
	//-------------------------------------------------

 	window.addEventListener("load", function()
	{
		if (EB.isInitialized()) startAd();
		else EB.addEventListener(EBG.EventName.EB_INITIALIZED, function() { return startAd.apply(this, arguments); });
		setText();
		
	});

	window.addEventListener("resize",setText);

 	function startAd()
 	{
		adId 	= EB._adConfig.adId;
		rnd 	= EB._adConfig.rnd;
		uid 	= EB._adConfig.uid;	
		addEventListeners();
		trackGutters();
 	}

	function setText()
    {		
    	var _CTA = document.getElementById("click_CTA");
			_CTA.style.display="block";
    	var _description = document.getElementById("description");
		var _CTATopOffset = 0;
		if(_description.offsetWidth<200)
		{ 
			_description.innerHTML ="See and be seen";
			_CTATopOffset=_CTA.style.top =_description.offsetTop+_description.offsetHeight+3+'px';
		}
        else
	{
			_description.innerHTML="Sizmek brings together the technology, intelligence, and strategic service you want to create inspiring advertising everywhere and drive exponential performance";
   			_CTATopOffset=_CTA.style.top =_description.offsetTop+_description.offsetHeight+30+'px';
		}
		setTimeout(function(){_CTA.style.top=_CTATopOffset+'px';},100); 
	}

 	function trackGutters()
	{
		var autoEventName = 'Right_Gutter_Viewed';

		if(!EB._adConfig[autoEventName])
		{
			EB.automaticEventCounter(autoEventName);
			var data = {
				autoEventName : autoEventName
			};
			self.dispatchJSEvent('trackGutterAutoInteraction',data);
		}
	}
	
	function dummyFunction()
	{
		EB.automaticEventCounter('Right_Gutter_Viewed');
	}
	
 	function addEventListeners() 
 	{
    	document.getElementById("click_CTA").addEventListener("click", clickthrough);
	}

	function clickthrough() 
	{
    	EB.clickthrough();
	}

	function creativeContainerReady()
	{
		// Add logic when ad container is ready.
	}
	//-------------------------------------------------
	//End of Creative Functions
	//=================================================


 	/***************************************************************************/
	/*Initialization : Must be down here after the prototype is fully defined  */
	/***************************************************************************/
	var creative = new Creative(); //create our 'self' class object which holds all of our functionality
})();